local Emphasize = Grid:GetModule("GridStatus"):GetModule("GridStatusEmphasize")
local GridStatusEmphasize_BigWigs = Emphasize:NewModule("GridStatusEmphasize_BigWigs", "AceEvent-2.0")

GridStatusEmphasize_BigWigs.defaultDB = {
	flashnshake = true,
	super_emphasize = true,
}

local options = {
	["flashnshake"] = {
		type = "toggle",
		name = "Flash Grid on Flash and Shake",
		desc = "Flash Grid on Flash and Shake",
		get = function () return GridStatusEmphasize_BigWigs.db.profile.flashnshake end,
		set = function (v) GridStatusEmphasize_BigWigs.db.profile.flashnshake = v end,
	},
	["superemphasize"] = {
		type = "toggle",
		name = "Flash Grid on Super Emphasize",
		desc = "Flash Grid on Super Emphasize",
		get = function () return GridStatusEmphasize_BigWigs.db.profile.super_emphasize end,
		set = function (v) GridStatusEmphasize_BigWigs.db.profile.super_emphasize = v end,
	},
}

function GridStatusEmphasize_BigWigs:OnInitialize()
	self.super.OnInitialize(self)

   self:RegisterEvent("ADDON_LOADED")
   
   self:RegisterOptions("Big Wigs", options)
end

function GridStatusEmphasize_BigWigs:ADDON_LOADED(modname)
	if modname == "BigWigs_Core" then
		self:InitializeBigWigs()
	end
end

function GridStatusEmphasize_BigWigs:InitializeBigWigs()
	local bwplugin = BigWigs:NewPlugin("GridStatusEmphasize_BigWigs")	

	function bwplugin:OnPluginEnable()
		self:RegisterMessage("BigWigs_FlashShake", "FlashGrid")
		self:RegisterMessage("BigWigs_SuperEmphasizeStart", "FlashGrid")
	end

	function bwplugin:FlashGrid()
		Emphasize:Flash()
	end
end
