local Emphasize = Grid:GetModule("GridStatus"):GetModule("GridStatusEmphasize")
local GridStatusEmphasize_Tanks = Emphasize:NewModule("GridStatusEmphasize_Tanks", "AceEvent-2.0")

local GridRoster = Grid:GetModule("GridRoster")

GridStatusEmphasize_Tanks.defaultDB = {
	always_show_tanks = true,
}

local options = {
	["show_tanks"] = {
		type = "toggle",
		name = "Never fade out tanks",
		desc = "Always keep tanks visible, even during emphasized events",
		get = function () return GridStatusEmphasize_Tanks.db.profile.always_show_tanks end,
		set = function (v) GridStatusEmphasize_Tanks.db.profile.always_show_tanks = v end,
	},
}

function GridStatusEmphasize_Tanks:OnInitialize()
	self.super.OnInitialize(self)
	
	self:RegisterOptions("Tanks", options)
	
	self:RegisterEvent("PLAYER_ROLES_ASSIGNED", "UpdateMainTanks")
	self:RegisterEvent("LFG_ROLE_UPDATE", "UpdateMainTanks")
	self:RegisterEvent("PLAYER_LOGIN", "UpdateMainTanks")
end		

function GridStatusEmphasize_Tanks:UpdateMainTanks()
	self:Debug("update mts")

	Emphasize:Pause()

	Emphasize:StaticDeemphasizeAllUnits("main_tank")
	
	if GridRoster:GetPartyState() ~= "solo" and	GridRoster:GetPartyState() ~= "bg" and GridRoster:GetPartyState() ~= "arena" then
		for guid, unitid in GridRoster:IterateRoster() do
			--local islfgtank, _, _ = UnitGroupRolesAssigned(unitid)
			if (UnitInParty(unitid) or UnitInRaid(unitid)) and (GetPartyAssignment("MAINTANK", unitid) or UnitGroupRolesAssigned(unitid) == true) then
				self:Debug(UnitName(unitid) .. " is tank - " .. UnitGUID(unitid) .. " - " .. guid)
				Emphasize:StaticEmphasizeUnit(guid, "main_tank")
			end
		end
	end

	Emphasize:Resume()	
end
